<template>
  <el-dialog :title="title" :visible.sync="dialogFormVisible" width="800px" @close="close">
    <el-form ref="form" :model="form" :rules="rules">
      <div class="lists">
        <el-form-item label="id" prop="id">
          <el-input class="inputs" v-model="form.id" autocomplete="off" :disabled="!idAdd?true:false"></el-input>
        </el-form-item>
        <el-form-item label="编码" prop="code">
          <el-input class="inputs" v-model.trim="form.code" autocomplete="off"></el-input>
        </el-form-item>
      </div>
      <div class="lists">
        <el-form-item label="线路名称" prop="name">
          <el-input class="inputs" v-model="form.name" autocomplete="off"></el-input>
        </el-form-item>
        <el-form-item label="别称" prop="aname">
          <el-input class="inputs" v-model.trim="form.aname" autocomplete="off"></el-input>
        </el-form-item>
      </div>
      <div class="lists">
        <el-form-item label="期次" prop="projectid">
          <el-input class="inputs" v-model.trim="form.projectid" autocomplete="off"></el-input>
        </el-form-item>
        <el-form-item label="装机容量" prop="capacity">
          <el-input class="inputs" v-model.number="form.capacity" autocomplete="off"
            @blur="onBlur(form.capacity,'capacity')">
          </el-input>
        </el-form-item>
      </div>
      <div class="lists">
        <el-form-item label="容量单位" prop="capacityunit">
          <el-input class="inputs" v-model.trim="form.capacityunit" autocomplete="off"></el-input>
        </el-form-item>
        <el-form-item label="装机数量" prop="quantity">
          <el-input class="inputs" v-model.number="form.quantity" autocomplete="off"
            @blur="onBlur(form.quantity,'quantity')"></el-input>
        </el-form-item>
      </div>
      <div class="lists">
        <el-form-item label="顺序" prop="ordernum">
          <el-input class="inputs" v-model.trim="form.ordernum" autocomplete="off"></el-input>
        </el-form-item>
      </div>
    </el-form>
    <div slot="footer" class="dialog-footer">
      <el-button @click="close">取 消</el-button>
      <el-button type="primary" @click="save">确 定</el-button>
    </div>
  </el-dialog>
</template>

<script>
import api from '@/api/station'
import dayjs from "dayjs";
export default {
  name: 'TableEdit',
  props: {
    options: {
      type: Array,
      default: []
    },
    stationList: {
      type: Array,
      // 报错
      // default: []
      default: function() {
			  return []
		  }
    },
  },
  data() {
    return {
      form: {
        id: '',
        name: '',
        code: '',
      },
      rules: {
        id: [{ required: true, trigger: 'blur', message: '请输入' }],
        name: [{ required: true, trigger: 'blur', message: '请输入' }],
        code: [{ required: true, trigger: 'blur', message: '请输入' }],
        aname: [{ required: true, trigger: 'blur', message: '请输入' }],
        capacity: [{ required: true, trigger: 'blur', message: '请输入' }],
        capacityunit: [{ required: true, trigger: 'blur', message: '请输入' }],
        model: [{ required: true, trigger: 'blur', message: '请输入' }],
        ordernum: [{ required: true, trigger: 'blur', message: '请输入' }],
        quantity: [{ required: true, trigger: 'blur', message: '请输入' }],
      },
      title: '',
      dialogFormVisible: false,
      idAdd: true,
    }
  },
  created() { },
  methods: {
    showEdit(row) {
      if (!row) {
        this.title = '添加'
        this.idAdd = true
      } else {
        this.title = '编辑'
        this.idAdd = false
        this.form = Object.assign({}, row)
      }
      this.dialogFormVisible = true
    },
    close() {
      this.$refs['form'].resetFields()
      this.form = this.$options.data().form
      this.dialogFormVisible = false
      this.$emit('fetch-data')
    },
    save() {
      this.$refs['form'].validate(async (valid) => {
        if (valid) {
          api.addLine(this.form).then(res => {
            if (res.data) {
              this.$message({
                type: 'success',
                message: '添加成功!'
              });
              this.$emit('save-success');
              this.dialogFormVisible = false
            }
          })
        } else {
          return false
        }
      })
    },
    handleChange() {
    },
    onBlur(val, param) {
      if (typeof (this.form[param]) !== 'number') {
        this.form[param] = val.replace(/[^0-9]/ig, "")
      }
    },
  },
}
</script>
<style lang="less" scoped>
.inputs {
  width: 200px;
}

.lists {
  display: flex;
  flex-direction: row;
  align-items: center;
  justify-content: space-between;
}
</style>
